/*****************************************************
This program was produced by the
CodeWizardAVR V2.05.0 Professional
Automatic Program Generator
 Copyright 1998-2010 Pavel Haiduc, HP InfoTech s.r.l.
http://www.hpinfotech.com

Project : 
Version : 
Date    : 19.06.2014
Author  : NeVaDa
Company : 
Comments: 


Chip type               : ATtiny13A
AVR Core Clock frequency: 4,000000 MHz
Memory model            : Tiny
External RAM size       : 0
Data Stack size         : 16
*****************************************************/

#include <tiny13a.h>

#include <delay.h>

unsigned int adc_data;
#define ADC_VREF_TYPE 0x40

// ADC interrupt service routine
interrupt [ADC_INT] void adc_isr(void)
{
// Read the AD conversion result
adc_data=ADCW;
}

// Read the AD conversion result
// with noise canceling
unsigned int read_adc(unsigned char adc_input)
{
ADMUX=adc_input | (ADC_VREF_TYPE & 0xff);
// Delay needed for the stabilization of the ADC input voltage
delay_us(10);
#asm
    in   r30,mcucr
    cbr  r30,__sm_mask
    sbr  r30,__se_bit | __sm_adc_noise_red
    out  mcucr,r30
    sleep
    cbr  r30,__se_bit
    out  mcucr,r30
#endasm
return adc_data;
}

// Declare your global variables here

int show_working;
/*
int kol_srabativaniy_vverh;
int kol_srabativaniy_vniz;
int nagruzka_podkluchena;
void anti_drebezg_vverh()
{
    if (kol_srabativaniy_vverh<5) kol_srabativaniy_vverh++; 
    
    if (kol_srabativaniy_vverh>3)
    {
     nagruzka_podkluchena =1;
     kol_srabativaniy_vniz=0;
    }
}

void anti_drebezg_vniz()
{
    if (kol_srabativaniy_vniz<5) kol_srabativaniy_vniz++; 
    
    if (kol_srabativaniy_vniz>3) 
    {
        kol_srabativaniy_vverh=0;
        nagruzka_podkluchena=0;
    }
}
 */
void main(void)
{
int U_value;
// Declare your local variables here

// Crystal Oscillator division factor: 1
#pragma optsize-
CLKPR=0x80;
CLKPR=0x00;
#ifdef _OPTIMIZE_SIZE_
#pragma optsize+
#endif
 
  
// Input/Output Ports initialization
// Port B initialization
// Func5=In Func4=In Func3=In Func2=Out Func1=Out Func0=Out 
// State5=T State4=T State3=T State2=0 State1=0 State0=0 
PORTB=0x00;
DDRB=0x07;

// Timer/Counter 0 initialization
// Clock source: System Clock
// Clock value: Timer 0 Stopped
// Mode: Normal top=0xFF
// OC0A output: Disconnected
// OC0B output: Disconnected
TCCR0A=0x00;
TCCR0B=0x00;
TCNT0=0x00;
OCR0A=0x00;
OCR0B=0x00;

// External Interrupt(s) initialization
// INT0: Off
// Interrupt on any change on pins PCINT0-5: Off
GIMSK=0x00;
MCUCR=0x00;

// Timer/Counter 0 Interrupt(s) initialization
TIMSK0=0x00;

// Analog Comparator initialization
// Analog Comparator: Off
ACSR=0x80;
ADCSRB=0x00;
DIDR0=0x00;

// ADC initialization
// ADC Clock frequency: 31.250 kHz
// ADC Bandgap Voltage Reference: On
// ADC Auto Trigger Source: ADC Stopped
// Digital input buffers on ADC0: Off, ADC1: Off, ADC2: On, ADC3: Off
DIDR0&=0x03;
DIDR0|=0x2C;
ADMUX=ADC_VREF_TYPE & 0xff;
ADCSRA=0x8F;  
  
// Global enable interrupts
#asm("sei")

/*
kol_srabativaniy_vverh=0;
kol_srabativaniy_vniz=0;
nagruzka_podkluchena=0;
*/
show_working=0;

while (1)
{
U_value =  read_adc(2);     
      

        if (U_value>576)
        {
                //  3
                PORTB.0=1;  
                PORTB.1=1; 
                delay_ms(4000);

                                                
                //  2
                PORTB.0=0;  
                PORTB.1=0;
                delay_ms(2000);
        }
        else
        {
                //  
                PORTB.0=0;  
                PORTB.1=0;
                 

                if (show_working<10) 
                {
                show_working++;
                }
                else
                {
                show_working=0;
                PORTB.2=1; 
                delay_ms(500);
                PORTB.2=0;     
                }
                delay_ms(500);                        
        }
        
} // 
}
